//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include <MovingAverages.mqh>
//+------------------------------------------------------------------+
#property strict
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
extern int Period_=10;
extern int MA1    =10;// 
extern int MA2    =10;// 
double t;
//--- buffers
double ExtMapBuffer[];
double ma1[];
double ma2[];
int BEGUN;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   t=double(Period_);
   BEGUN=Period_+MA1+MA2;
   IndicatorBuffers(3);
   SetIndexBuffer(2,ExtMapBuffer);
   SetIndexBuffer(1,ma1);
   SetIndexBuffer(0,ma2);
   IndicatorDigits(Digits+1);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int i,limit;
   double tg;
   if(prev_calculated==0) limit=rates_total-1-BEGUN;
   else limit=rates_total-prev_calculated;
   for(i=limit;i>=0;i--)
     {
      tg=((close[i]-iMA(NULL,0,Period_,0,MODE_EMA,PRICE_CLOSE,i))/Point)/t;
      ExtMapBuffer[i]=tg;
     }
   ExponentialMAOnBuffer(rates_total,prev_calculated,BEGUN,MA1,ExtMapBuffer,ma1);
   ExponentialMAOnBuffer(rates_total,prev_calculated,BEGUN,MA2,ma1,ma2);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
